package starj.toolkits.services;

import starj.events.MethodEvent;

public class ExecutionContext implements Cloneable {
    private ThreadEntity thread;
    private MethodEntity method;
    
    public ExecutionContext(MethodEvent event) {
        this(IDResolver.v().getThreadEntity(event.getEnvID()),
                IDResolver.v().getMethodEntity(event.getMethodID()));
    }
    
    public ExecutionContext(ThreadEntity thread, MethodEntity method) {
        this.thread = thread;
        this.method = method;
    }

    public ThreadEntity getThread() {
        return this.thread;
    }

    public MethodEntity getMethod() {
        return this.method;
    }

    void setThread(ThreadEntity thread) {
        this.thread = thread;
    }

    void setMethod(MethodEntity method) {
        this.method = method;
    }
    
    public Object clone()  {
        return new ExecutionContext(this.thread, this.method);
    }

    // FIXME: equals, hashCode, toString, etc.
}
